class com.ndimedia.scoobysoccer.Ball extends com.warnerbros.games.BaseObject
{
   var speed;
   var m_position;
   var m_radius;
   var mc;
   var m_frozen;
   var m_rotationVelocity;
   var velocity;
   var m_direction;
   var alive;
   static var ANIM_DEFLATES = 1;
   static var ANIM_EXPLODES = 2;
   static var ANIM_BOUNCE = 3;
   function Ball(x, y, ball_speed, movie_clip, name)
   {
      super(x,y,movie_clip,name);
      this.speed = ball_speed;
      this.m_position = {x:200,y:30};
      this.m_radius = this.mc._height / 2;
      this.mc.number_tfd.text = name;
      this.m_frozen = false;
   }
   function get radius()
   {
      return this.m_radius;
   }
   function setRotationVelocity(deg)
   {
      this.m_rotationVelocity = deg;
   }
   function setPosition(p)
   {
      if(Math.abs(this.velocity.x) > Math.abs(this.velocity.y))
      {
         this.m_direction = "H";
      }
      else
      {
         this.m_direction = "V";
      }
      this.m_direction += this.velocity.x <= 0 ? "-" : "+";
      this.mc._x = p.x;
      this.mc._y = p.y;
      this.m_position = p;
      if(this.m_rotationVelocity > 0)
      {
         this.mc._rotation += this.m_rotationVelocity--;
      }
      else if(this.m_rotationVelocity < 0)
      {
         this.mc._rotation += this.m_rotationVelocity++;
      }
   }
   function get direction()
   {
      return this.m_direction;
   }
   function freeze()
   {
      this.m_frozen = true;
      this.setPosition({x:-1000,y:-1000});
   }
   function unfreeze(p, v)
   {
      this.setPosition(p);
      this.velocity = v;
      this.m_frozen = false;
   }
   function get position()
   {
      return this.m_position;
   }
   function addToVelocity(v)
   {
      if(!this.m_frozen)
      {
         com.warnerbros.games.VectorMath.addVectors(this.velocity,v);
      }
   }
   function applyVelocity()
   {
      if(!this.m_frozen)
      {
         com.warnerbros.games.VectorMath.addVectors(this.m_position,this.velocity);
         this.setPosition(this.m_position);
      }
   }
   function die(anim)
   {
      trace("destroy: " + anim);
      switch(anim)
      {
         case com.ndimedia.scoobysoccer.Ball.ANIM_EXPLODES:
            this.mc.gotoAndPlay("explodes");
            break;
         case com.ndimedia.scoobysoccer.Ball.ANIM_DEFLATES:
            this.mc.gotoAndPlay("deflates");
            break;
         case com.ndimedia.scoobysoccer.Ball.ANIM_BOUNCE:
            this.mc.gotoAndPlay("bounce");
      }
      this.alive = false;
      this.mc.onAnimDone = com.ndimedia.utils.Proxy.create(this,this.destroy);
   }
}
