class com.ndimedia.scoobysoccer.GameController extends com.warnerbros.games.BaseGameController
{
   var gameTimeline;
   var m_newLife;
   var bonusMode;
   var HM;
   var SM;
   var MM;
   var pause;
   var alert;
   var m_trickBall;
   var avatar;
   var mcHS;
   var m_surfaceBounce;
   var m_surfaceFriction;
   var m_gravity;
   var m_sndLoop;
   var m_mcSoundLoop;
   var bmQxtraBalls;
   var bmDuration;
   var effectsAudio;
   var soundtrackAudio;
   static var $$instance = null;
   var m_inPlay = true;
   var ballQuantity = 0;
   var trickEnabled = false;
   var debutDeJeu = true;
   var trickSequence = false;
   var delayedBM = false;
   var elementsObj = {};
   static var LEFT = -1;
   static var RIGHT = 1;
   static var BOTTOM = 365;
   static var CONSTANT_BOUNCE_VELOCITY = -20;
   static var X_DEF_GRAVITY = 0;
   static var Y_DEF_GRAVITY = 0.95;
   static var Y_DEF_AVATAR_POSITION = 350;
   static var SPACEBAR = 32;
   static var STAGE_WIDTH = 250;
   static var BALL_ROTATION_VELOCITY = -40;
   static var SND_BOUNCE = 1;
   var debugMode = false;
   function GameController()
   {
      super();
   }
   static function getInstance()
   {
      if(com.ndimedia.scoobysoccer.GameController.$$instance == null)
      {
         com.ndimedia.scoobysoccer.GameController.$$instance = new com.ndimedia.scoobysoccer.GameController();
         mx.events.EventDispatcher.initialize(com.ndimedia.scoobysoccer.GameController.$$instance);
      }
      return com.ndimedia.scoobysoccer.GameController.$$instance;
   }
   function init(game_timeline, engine_clip)
   {
      this.gameTimeline = game_timeline;
      this.m_newLife = true;
      this.bonusMode = false;
      var _loc2_ = com.ndimedia.scoobysoccer.managers.GameDepthManager.getNextAudioControllerDepth();
      var _loc3_ = "sound_clip_container" + _loc2_;
      com.warnerbros.games.managers.BaseObjectManager.setTarget(this.gameTimeline);
      this.HM = com.ndimedia.scoobysoccer.managers.HudManager.getInstance();
      this.SM = com.ndimedia.scoobysoccer.managers.ScoreManager.getInstance();
      this.HM.init(this);
      this.SM.init(this);
      this.MM = com.ndimedia.scoobysoccer.managers.MessageManager.getInstance();
      this.MM.init(this);
      this.MM.addEventListener("keyPressed",mx.utils.Delegate.create(this,this.onKeyPressed));
   }
   function onKeyPressed(e)
   {
      if(this.pause)
      {
         if(e.keycode === com.ndimedia.scoobysoccer.GameController.SPACEBAR)
         {
            this.alert.removeMovieClip();
            this.MM.clearMsg();
            this.m_trickBall = this.spawnBall();
            this.m_trickBall.freeze();
            this.avatar.mc.gotoAndPlay("knee_move");
         }
      }
   }
   function hideAreasAndSurfaces()
   {
      this.gameTimeline.scooby_mc.footSurface_mc._alpha = 0;
      this.gameTimeline.scooby_mc.headSurface_mc._alpha = 0;
      this.gameTimeline.scooby_mc.tailSurface_mc._alpha = 0;
      this.gameTimeline.scooby_mc.headReactionZone_mc._alpha = 0;
   }
   function enlargeSurfaces()
   {
      this.gameTimeline.scooby_mc.footSurface_mc._width = 200;
      this.gameTimeline.scooby_mc.headSurface_mc._width = 200;
      this.gameTimeline.scooby_mc.tailSurface_mc._width = 200;
   }
   function start()
   {
      super.start();
      this.SM.reset();
      this.avatar = com.ndimedia.scoobysoccer.managers.ObjectManager.createAvatar(com.ndimedia.scoobysoccer.GameController.STAGE_WIDTH,com.ndimedia.scoobysoccer.GameController.Y_DEF_AVATAR_POSITION,10);
      this.avatar.reset();
      if(!this.debugMode)
      {
         this.hideAreasAndSurfaces();
      }
      if(this.debugMode)
      {
         this.enlargeSurfaces();
      }
      var _loc4_ = new Array(this.gameTimeline.leftWall_mc,this.gameTimeline.rightWall_mc,this.gameTimeline.floorSurface_mc);
      var _loc3_ = 0;
      while(_loc3_ < _loc4_.length)
      {
         com.warnerbros.games.managers.BaseObjectManager.addObject(_loc4_[_loc3_],"stageSurfaces");
         _loc3_ = _loc3_ + 1;
      }
      var _loc6_ = new Array(this.gameTimeline.scooby_mc.footSurface_mc,this.gameTimeline.scooby_mc.headSurface_mc,this.gameTimeline.scooby_mc.tailSurface_mc);
      _loc3_ = 0;
      while(_loc3_ < _loc6_.length)
      {
         com.warnerbros.games.managers.BaseObjectManager.addObject(_loc6_[_loc3_],"avatarSurfaces");
         _loc3_ = _loc3_ + 1;
      }
      var _loc5_ = new Array(this.gameTimeline.scooby_mc.headReactionZone_mc,this.gameTimeline.scooby_mc.backReactionZone_mc,this.gameTimeline.scooby_mc.frontReactionZone_mc);
      _loc3_ = 0;
      while(_loc3_ < _loc5_.length)
      {
         com.warnerbros.games.managers.BaseObjectManager.addObject(_loc5_[_loc3_],"avatarAreas");
         _loc3_ = _loc3_ + 1;
      }
      this.HM.init(this.gameTimeline,this);
   }
   function spawnBall()
   {
      var _loc2_ = com.ndimedia.scoobysoccer.managers.ObjectManager.createBall(com.ndimedia.scoobysoccer.GameController.STAGE_WIDTH,0,0,11);
      com.warnerbros.games.managers.BaseObjectManager.addObject(_loc2_,"balls");
      this.ballQuantity = this.ballQuantity + 1;
      var _loc4_ = 50 + random(400);
      var _loc3_ = -20;
      var _loc5_ = com.warnerbros.games.VectorMath.newVector(_loc4_,_loc3_);
      _loc2_.setPosition(_loc5_);
      _loc2_.mc.number_tfd._visible = this.debugMode;
      return _loc2_;
   }
   function title()
   {
      super.title();
      this.mcHS.HS.setDialogLocation(175,100);
   }
   function play()
   {
      super.play();
      this.pause = true;
      this.avatar.setPosition(com.ndimedia.scoobysoccer.GameController.STAGE_WIDTH,com.ndimedia.scoobysoccer.GameController.Y_DEF_AVATAR_POSITION);
      this.avatar.mc._visible = true;
      this.m_surfaceBounce = -0.4;
      this.m_surfaceFriction = 0.2;
      this.m_gravity = com.warnerbros.games.VectorMath.newVector(com.ndimedia.scoobysoccer.GameController.X_DEF_GRAVITY,com.ndimedia.scoobysoccer.GameController.Y_DEF_GRAVITY);
      this.HM.update();
      this.HM.setHudVisibility(true);
      if(this.m_sndLoop == undefined || this.m_sndLoop.getVolume() != 100)
      {
         this.m_mcSoundLoop = this.gameTimeline.createEmptyMovieClip("soundLoop_mc",987456);
         this.m_sndLoop = new Sound(this.m_mcSoundLoop);
         this.m_sndLoop.attachSound("asambofunk02_softer.wav");
         this.m_sndLoop.setVolume(100);
         this.m_sndLoop.start(0,999);
      }
      this.alert = this.MM.createMsg(this.gameTimeline,"start","alert");
      this.m_inPlay = true;
   }
   function updateGravity(delta)
   {
      trace("delta = " + delta);
      this.m_gravity = com.warnerbros.games.VectorMath.newVector(com.ndimedia.scoobysoccer.GameController.X_DEF_GRAVITY,com.ndimedia.scoobysoccer.GameController.Y_DEF_GRAVITY + delta);
   }
   function _applyGravity()
   {
      var _loc4_ = com.warnerbros.games.managers.BaseObjectManager.getArray("balls");
      var _loc2_ = 0;
      while(_loc2_ < _loc4_.length)
      {
         var _loc3_ = com.ndimedia.scoobysoccer.Ball(_loc4_[_loc2_]);
         _loc3_.addToVelocity(this.m_gravity);
         _loc3_.applyVelocity();
         _loc2_ = _loc2_ + 1;
      }
   }
   function mainLoop()
   {
      super.mainLoop();
      com.ndimedia.scoobysoccer.managers.InputManager.processInput();
      if(!this.pause)
      {
         this.handleInput();
         this._applyGravity();
         this.checkCollision2Stage();
         this.checkCollision2Avatar();
         this.HM.update();
      }
   }
   function animationDone(fb, vel, override)
   {
      if(this.trickSequence)
      {
         if(typeof fb == "movieclip")
         {
            this.avatar.animDone = true;
            this.trickSequence = false;
            if(this.m_trickBall)
            {
               this.pause = false;
               var _loc3_ = {x:fb._x,y:fb._y};
               fb._parent.localToGlobal(_loc3_);
               if(!vel)
               {
                  var _loc5_ = {x:0,y:com.ndimedia.scoobysoccer.GameController.CONSTANT_BOUNCE_VELOCITY};
               }
               else
               {
                  _loc5_ = {x:0,y:vel};
               }
               this.m_trickBall.unfreeze(_loc3_,_loc5_);
               this.m_trickBall = null;
            }
         }
      }
      else
      {
         this.avatar.animDone = true;
         this.trickSequence = false;
         if(this.m_trickBall)
         {
            this.pause = false;
            _loc3_ = {x:fb._x,y:fb._y};
            fb._parent.localToGlobal(_loc3_);
            if(!vel)
            {
               _loc5_ = {x:0,y:com.ndimedia.scoobysoccer.GameController.CONSTANT_BOUNCE_VELOCITY};
            }
            else
            {
               _loc5_ = {x:0,y:vel};
            }
            this.m_trickBall.unfreeze(_loc3_,_loc5_);
            this.m_trickBall = null;
         }
      }
      if(this.delayedBM)
      {
         this.startBonusMode(this.bmQxtraBalls,this.bmDuration);
      }
   }
   function switchTrick(state)
   {
      this.trickEnabled = state;
   }
   function startBonusMode(qxtraballs, duration)
   {
      if(this.bonusMode == false)
      {
         this.bmQxtraBalls = qxtraballs;
         this.bmDuration = duration;
         this.delayedBM = this.trickSequence;
         if(this.delayedBM)
         {
            return undefined;
         }
         this.bonusMode = true;
         this.alert = this.MM.createMsg(this.gameTimeline,"bonus","alert",1000);
         var _loc2_ = 0;
         while(_loc2_ < qxtraballs)
         {
            this.spawnBall();
            _loc2_ = _loc2_ + 1;
         }
         this.SM.startBonusTimer(duration);
      }
   }
   function stopBonusMode()
   {
      this.bonusMode = false;
      this.SM.bonusScore = 0;
   }
   function _getReboundXVelocity(surface, ballX)
   {
      var _loc3_ = surface.getBounds(this.gameTimeline);
      var _loc4_ = _loc3_.xMax - ballX;
      var _loc6_ = 1;
      var _loc5_ = undefined;
      var _loc2_ = (_loc3_.xMax - _loc3_.xMin) / 2;
      if(_loc4_ < _loc2_)
      {
         _loc5_ = _loc4_ / _loc2_ * _loc6_ + 1;
      }
      else
      {
         _loc5_ = (- (_loc4_ - _loc2_)) / _loc2_ * _loc6_ - 1;
      }
      return _loc5_;
   }
   function handleInput()
   {
      super.handleInput();
      if(com.warnerbros.games.managers.BaseInputManager.checkInputState(com.ndimedia.scoobysoccer.managers.InputManager.MOVE_LEFT))
      {
         if(this.avatar.ready && this.avatar.animDone && this.avatar.mc._x > 60)
         {
            this.avatar.walk(com.ndimedia.scoobysoccer.GameController.LEFT);
            this.avatar.walkingLeft = true;
            this.avatar.waiting = false;
         }
      }
      else
      {
         this.avatar.walkingLeft = false;
      }
      if(com.warnerbros.games.managers.BaseInputManager.checkInputState(com.ndimedia.scoobysoccer.managers.InputManager.MOVE_RIGHT))
      {
         if(this.avatar.ready && this.avatar.animDone && this.avatar.mc._x < Stage.width - 60)
         {
            this.avatar.walk(com.ndimedia.scoobysoccer.GameController.RIGHT);
            this.avatar.walkingRight = true;
            this.avatar.waiting = false;
         }
      }
      else
      {
         this.avatar.walkingRight = false;
      }
      if(com.warnerbros.games.managers.BaseInputManager.checkInputState(com.ndimedia.scoobysoccer.managers.InputManager.KICK) && !this.trickSequence)
      {
         if(this.avatar.ready)
         {
            this.elementsObj = this.checkProximity();
            this.avatar.kick(this.elementsObj.closestBall,this.elementsObj.closestArea);
         }
      }
      else
      {
         this.avatar.ready = true;
      }
      if(com.warnerbros.games.managers.BaseInputManager.checkInputState(com.ndimedia.scoobysoccer.managers.InputManager.TRICK) && this.trickEnabled)
      {
         this.trickSequence = true;
         if(this.avatar.ready)
         {
            this.elementsObj = this.checkIfContact();
            this.m_trickBall = this.elementsObj.contactBall;
            this.m_trickBall.freeze();
            var _loc4_ = this.avatar.superkick(this.elementsObj.contactBall,this.elementsObj.contactArea);
            if(_loc4_)
            {
               var _loc3_ = this.avatar.mc._x;
               if(_loc3_ < 120)
               {
                  _loc3_ = 120;
               }
               else if(_loc3_ > 400)
               {
                  _loc3_ = 400;
               }
               this.gameTimeline.attachMovie("bonusPoints_mc","bonusPoints_mc",99999,{_x:_loc3_,_y:200});
            }
            this.SM.resetTrickMeter(_loc4_);
            this.trickEnabled = false;
            this.avatar.override();
         }
      }
   }
   function checkCollision2Stage()
   {
      var _loc7_ = com.warnerbros.games.managers.BaseObjectManager.getArray("stageSurfaces");
      var _loc6_ = com.warnerbros.games.managers.BaseObjectManager.getArray("balls");
      var _loc5_ = 0;
      while(_loc5_ < _loc7_.length)
      {
         var _loc3_ = 0;
         while(_loc3_ < _loc6_.length)
         {
            var _loc4_ = _loc7_[_loc5_];
            var _loc2_ = com.ndimedia.scoobysoccer.Ball(_loc6_[_loc3_]);
            if(_loc2_.mc.hitTest(_loc4_))
            {
               if(_loc4_._name == "floorSurface_mc")
               {
                  this.bounceToFloor(_loc2_);
               }
               else
               {
                  if(_loc2_.position.x > com.ndimedia.scoobysoccer.GameController.STAGE_WIDTH)
                  {
                     _loc2_.setPosition(com.warnerbros.games.VectorMath.newVector(_loc2_.position.x - _loc2_.radius,_loc2_.position.y));
                  }
                  else
                  {
                     _loc2_.setPosition(com.warnerbros.games.VectorMath.newVector(_loc2_.position.x + _loc2_.radius,_loc2_.position.y));
                  }
                  _loc2_.velocity = com.warnerbros.games.VectorMath.newVector(_loc2_.velocity.x * -1,_loc2_.velocity.y);
               }
            }
            _loc3_ = _loc3_ + 1;
         }
         _loc5_ = _loc5_ + 1;
      }
   }
   function checkCollision2Avatar()
   {
      var _loc15_ = com.warnerbros.games.managers.BaseObjectManager.getArray("avatarSurfaces");
      var _loc7_ = com.warnerbros.games.managers.BaseObjectManager.getArray("balls");
      var _loc10_ = undefined;
      var _loc6_ = undefined;
      if(!this.debugMode)
      {
         this.hideAreasAndSurfaces();
      }
      if(this.debugMode)
      {
         this.enlargeSurfaces();
      }
      var _loc8_ = 0;
      while(_loc8_ < _loc15_.length)
      {
         var _loc5_ = 0;
         while(_loc5_ < _loc7_.length)
         {
            var _loc2_ = com.ndimedia.scoobysoccer.Ball(_loc7_[_loc5_]);
            var _loc3_ = _loc15_[_loc8_];
            _loc10_ = {x:_loc3_._x,y:_loc3_._y};
            _loc3_.localToGlobal(_loc10_);
            var _loc4_ = _loc3_.getBounds(this.gameTimeline);
            if(_loc2_.position.x > _loc4_.xMin && _loc2_.position.x < _loc4_.xMax)
            {
               if(_loc2_.position.y + _loc2_.radius > _loc4_.yMin && _loc2_.position.y - _loc2_.radius < _loc4_.yMax)
               {
                  this._playSound(com.ndimedia.scoobysoccer.GameController.SND_BOUNCE);
                  this.SM.updateScore("KICK");
                  _loc2_.setPosition(com.warnerbros.games.VectorMath.newVector(_loc2_.position.x,_loc2_.position.y - _loc2_.radius));
                  _loc6_ = this._getReboundXVelocity(_loc3_,_loc2_.position.x);
                  _loc2_.velocity = com.warnerbros.games.VectorMath.newVector(_loc2_.velocity.x + _loc6_,com.ndimedia.scoobysoccer.GameController.CONSTANT_BOUNCE_VELOCITY);
                  _loc2_.setRotationVelocity(_loc6_ / Math.abs(_loc6_) * com.ndimedia.scoobysoccer.GameController.BALL_ROTATION_VELOCITY);
                  if(this.bonusMode)
                  {
                     var _loc9_ = this.gameTimeline.attachMovie("bonusPoints_mc","bonusPoints_mc",this.gameTimeline.getNextHighestDepth(),{_x:this.avatar.mc._x,_y:200});
                     _loc9_.bonus_mc.bonusDisplay_mc.gotoAndStop(String("_" + _loc7_.length * 10));
                  }
               }
               this.effectsAudio.playSound("bounce");
            }
            _loc5_ = _loc5_ + 1;
         }
         _loc8_ = _loc8_ + 1;
      }
   }
   function checkProximity()
   {
      var _loc10_ = 99999;
      var _loc9_ = com.warnerbros.games.managers.BaseObjectManager.getArray("balls");
      var _loc5_ = {};
      var _loc6_ = 0;
      while(_loc6_ < _loc9_.length)
      {
         var _loc4_ = com.ndimedia.scoobysoccer.Ball(_loc9_[_loc6_]);
         var _loc8_ = this.avatar.spot;
         var _loc2_ = {x:0,y:0};
         _loc8_.localToGlobal(_loc2_);
         var _loc3_ = {x:0,y:0};
         _loc4_.mc.localToGlobal(_loc3_);
         var _loc7_ = Math.floor(Math.sqrt((_loc3_.x - _loc2_.x) * (_loc3_.x - _loc2_.x) + (_loc3_.y - _loc2_.y) * (_loc3_.y - _loc2_.y)));
         if(Math.abs(_loc7_) < _loc10_)
         {
            _loc10_ = Math.abs(_loc7_);
            _loc5_.closestBall = _loc4_;
            _loc5_.closestArea = _loc3_.x >= _loc2_.x ? "front" : "back";
            if(_loc3_.y < _loc2_.y && Math.abs(_loc3_.x - _loc2_.x) < _loc4_.radius)
            {
               _loc5_.closestArea = "head";
            }
            else
            {
               if(_loc4_.direction == "H-")
               {
                  _loc5_.closestArea = "back";
               }
               if(_loc4_.direction == "H+")
               {
                  _loc5_.closestArea = "front";
               }
            }
         }
         _loc6_ = _loc6_ + 1;
      }
      return _loc5_;
   }
   function checkIfContact()
   {
      var _loc7_ = com.warnerbros.games.managers.BaseObjectManager.getArray("avatarAreas");
      var _loc6_ = com.warnerbros.games.managers.BaseObjectManager.getArray("balls");
      var _loc5_ = {contactBall:null,contactArea:null};
      var _loc4_ = 0;
      while(_loc4_ < _loc7_.length)
      {
         var _loc1_ = 0;
         while(_loc1_ < _loc6_.length)
         {
            var _loc2_ = com.ndimedia.scoobysoccer.Ball(_loc6_[_loc1_]);
            var _loc3_ = _loc7_[_loc4_];
            if(_loc2_.mc.hitTest(_loc3_))
            {
               _loc5_.contactBall = _loc2_;
               _loc5_.contactArea = _loc3_;
            }
            _loc1_ = _loc1_ + 1;
         }
         _loc4_ = _loc4_ + 1;
      }
      return _loc5_;
   }
   function bounceToFloor(ball)
   {
      if(!this.bonusMode || Math.abs(ball.velocity.y) < 1)
      {
         this.killBall(ball);
         this.checkBalls();
      }
      else
      {
         ball.velocity = com.warnerbros.games.VectorMath.newVector(ball.velocity.x,Math.abs(ball.velocity.y) * -1);
         this._playSound(com.ndimedia.scoobysoccer.GameController.SND_BOUNCE);
         ball.setRotationVelocity(ball.velocity.x / Math.abs(ball.velocity.x) * com.ndimedia.scoobysoccer.GameController.BALL_ROTATION_VELOCITY);
      }
   }
   function killBall(b)
   {
      com.ndimedia.scoobysoccer.managers.ObjectManager.removeNamedObject("balls",b.name);
      this.ballQuantity = this.ballQuantity - 1;
      trace("SM.getLives() = " + this.SM.getLives());
      if(this.ballQuantity == 0)
      {
         if(this.SM.getLives() == 1)
         {
            b.die(com.ndimedia.scoobysoccer.Ball.ANIM_DEFLATES);
         }
         else
         {
            b.die(com.ndimedia.scoobysoccer.Ball.ANIM_EXPLODES);
         }
      }
      else
      {
         b.die(com.ndimedia.scoobysoccer.Ball.ANIM_EXPLODES);
      }
   }
   function checkBalls()
   {
      if(this.ballQuantity == 0)
      {
         this.SM.updateLives(-1);
         this.m_newLife = true;
         this.checkLives();
      }
   }
   function checkLives()
   {
      trace("SM.getLives() = " + this.SM.getLives());
      switch(this.SM.getLives())
      {
         case 0:
            this.gameTimeline.gotoAndPlay("gameOver");
            break;
         case 1:
            var p = this;
            var playDelay = setInterval(function()
            {
               p.gameTimeline.bg.gotoAndPlay("day");
               p.gameTimeline.gotoAndPlay("play");
               clearInterval(playDelay);
            }
            ,2000);
            break;
         default:
            trace("gameTimeline.gotoAndPlay(\"play\");");
            var p = this;
            var playDelay = setInterval(function()
            {
               p.gameTimeline.gotoAndPlay("play");
               clearInterval(playDelay);
            }
            ,2000);
      }
      this.SM.resetTrickMeter();
   }
   function gameOver()
   {
      super.gameOver(null,this.SM.totalScore);
      this.soundtrackAudio.playTrack("level_loop",true);
      this.destroyObjects("balls");
      this.destroyObjects("stageSurfaces");
      this.destroyObjects("avatarSurfaces");
      this.avatar.reset();
      this.HM.setHudVisibility(false);
      this.HM.showFinalScore(this.gameTimeline);
      var soundScope = this.m_sndLoop;
      var soundMC = this.m_mcSoundLoop;
      var soundFadeOut = setInterval(function()
      {
         if(soundScope.getVolume() > 0)
         {
            soundScope.setVolume(soundScope.getVolume() - 10);
         }
         else
         {
            clearInterval(soundFadeOut);
            soundScope.stop("asambofunk02_softer.wav");
            soundMC.removeMovieClip();
         }
      }
      ,33);
   }
   function destroyObjects(array_id)
   {
      var _loc3_ = com.warnerbros.games.managers.BaseObjectManager.getArray(array_id);
      var _loc1_ = 0;
      while(_loc1_ < _loc3_.length)
      {
         var _loc2_ = com.warnerbros.games.BaseObject(_loc3_[_loc1_]);
         _loc2_.destroy();
         _loc2_ = null;
         _loc1_ = _loc1_ + 1;
      }
      com.warnerbros.games.managers.BaseObjectManager.resetArray(array_id);
   }
   function _playSound(id)
   {
      var _loc1_ = new Sound();
      if(id === com.ndimedia.scoobysoccer.GameController.SND_BOUNCE)
      {
         _loc1_.attachSound("bounce_snd");
      }
      _loc1_.start();
   }
}
