class com.warnerbros.games.AudioController
{
   var soundClipContainer;
   var soundClip;
   var soundList;
   var soundID;
   function AudioController(container)
   {
      this.soundClipContainer = container;
      var _loc2_ = this.soundClipContainer.getNextHighestDepth();
      var _loc3_ = "sound_clip_" + _loc2_;
      this.soundClip = this.soundClipContainer.createEmptyMovieClip(_loc3_,_loc2_);
      this.soundList = new Object();
   }
   function registerSound(sound_id)
   {
      this.soundList[sound_id] = new com.warnerbros.games.GameSound(this.soundClip,this,sound_id);
      this.soundList[sound_id].attachSound(sound_id);
   }
   function loadSound(sound_id, sound_url, is_streaming, play_when_loaded)
   {
      var _loc2_ = undefined;
      _loc2_ = new com.warnerbros.games.GameSound(this.soundClip,this,sound_id,sound_url,is_streaming,play_when_loaded);
      this.soundList[sound_id] = _loc2_;
      _loc2_.loadSound(sound_url,is_streaming);
      _loc2_.onLoad = function()
      {
         var _loc2_ = com.warnerbros.games.GameSound(this);
         _loc2_.stop();
         _loc2_.AC.onSoundLoaded(_loc2_.soundID);
      };
      _loc2_.onID3 = function()
      {
         var _loc2_ = com.warnerbros.games.GameSound(this);
         _loc2_.AC.onID3Detected(this.soundID);
      };
      return _loc2_;
   }
   function onSoundLoaded(sound_id)
   {
      var _loc2_ = this.soundList[sound_id];
      if(_loc2_.playWhenLoaded)
      {
         _loc2_.start();
      }
   }
   function onID3Detected(sound_id)
   {
      var _loc2_ = this.soundList[sound_id];
      trace("onID3Detected: soundID: " + sound_id);
      for(var _loc3_ in _loc2_.id3)
      {
         trace(_loc3_ + ": " + _loc2_.id3[_loc3_]);
      }
   }
   function playSound(sound_id, loop)
   {
      var _loc3_ = this.soundList[sound_id];
      for(var _loc2_ in this.soundList)
      {
         this.stopSoundNow(_loc2_);
      }
      if(loop)
      {
         _loc3_.onSoundComplete = function()
         {
            var _loc2_ = com.warnerbros.games.GameSound(this);
            trace("SoundInstance: looping: " + this);
            _loc2_.start();
         };
      }
      else
      {
         _loc3_.onSoundComplete = null;
      }
      _loc3_.start();
   }
   function stopSoundNow(sound_id)
   {
      var _loc2_ = com.warnerbros.games.GameSound(this.soundList[sound_id]);
      _loc2_.onSoundComplete = null;
      _loc2_.stop();
   }
   function stopSoundAtEndOfLoop(sound_id)
   {
      var _loc2_ = com.warnerbros.games.GameSound(this.soundList[sound_id]);
      if(_loc2_.onSoundComplete != undefined)
      {
         _loc2_.onSoundComplete = undefined;
      }
      else
      {
         _loc2_.stop();
      }
   }
   function setSoundVolume(sound_id, volume)
   {
      var _loc2_ = com.warnerbros.games.GameSound(this.soundList[sound_id]);
      _loc2_.setVolume(volume);
   }
}
