class com.warnerbros.games.BaseGameController
{
   var gameTimeline;
   var containerTimeline;
   var engineClip;
   var levelPauseTimer;
   var inputTimer;
   var mcHS;
   var debugMsgList;
   var mclListenerHS;
   var mclHS;
   var owner;
   var filenameHS = "HSScripts2.swf";
   var consoleCode = "";
   var prevConsoleCodeChar = 0;
   function BaseGameController(game_timeline, engine_clip)
   {
      this.gameTimeline = game_timeline;
      this.containerTimeline = this.gameTimeline._parent;
      if(this.containerTimeline == undefined && this.gameTimeline != _level0)
      {
         this.containerTimeline = _level0;
      }
      if(this.containerTimeline != undefined && this.containerTimeline.AC == undefined)
      {
         this.containerTimeline = _level10;
      }
      if(this.containerTimeline != undefined && this.containerTimeline.AC == undefined)
      {
         this.containerTimeline = _level10;
      }
      this.engineClip = engine_clip;
      this.engineClip._visible = false;
      this.levelPauseTimer = new com.warnerbros.games.Timer();
      this.inputTimer = new com.warnerbros.games.Timer();
   }
   function onHSReady()
   {
      trace("GC: onHSReady");
      this.mcHS.HS.loading();
      this.gameTimeline.gotoAndPlay("title");
   }
   function onHSLoadError(error_code)
   {
      trace("GC: onHSLoadError: Tracking and High Scores not available. : " + error_code);
      this.mcHS.HS = undefined;
      this.gameTimeline.gotoAndPlay("title");
   }
   function start()
   {
      this.debugMsgList = new Array();
      if(this.containerTimeline != undefined)
      {
         this.containerTimeline.AC.gameStart(this.gameTimeline,this);
      }
      else
      {
         this.gameDebug("Container: undefined");
      }
      this.mclListenerHS = new Object();
      this.mclListenerHS.owner = this;
      this.mclHS = new MovieClipLoader();
      this.mclListenerHS.onLoadComplete = function(target_mc)
      {
         target_mc.owner = this.owner;
      };
      this.mclListenerHS.onLoadError = function(target_mc, errorCode)
      {
         trace("HS: onLoadError: " + errorCode);
         this.owner.onHSLoadError(errorCode);
      };
      this.mclHS.addListener(this.mclListenerHS);
      if(this.gameTimeline.gGameID == undefined)
      {
         this.gameTimeline.gGameID = "na.no_id.fla";
      }
      if(this.gameTimeline.gHSRoot_swf == undefined)
      {
         this.gameTimeline.gHSRoot_swf = "";
      }
      if(this.gameTimeline.gHSRoot_jsp == undefined)
      {
         this.gameTimeline.gHSRoot_jsp = "/web/load_variables/games/";
      }
      if(this.gameTimeline.gHSRoot_top100 == undefined)
      {
         this.gameTimeline.gHSRoot_top100 = "/web/games/";
      }
      if(this.gameTimeline.gDB_domain == undefined)
      {
         this.gameTimeline.gDB_domain = "http://looneytunes2.warnerbros.com";
      }
      this.mcHS = this.gameTimeline.createEmptyMovieClip("hs_scripts2",24000);
      this.mclHS.loadClip(this.gameTimeline.gHSRoot_swf + this.filenameHS,this.mcHS);
   }
   function title()
   {
      if(this.containerTimeline != undefined)
      {
         this.containerTimeline.AC.gameTitle();
      }
      this.mcHS.HS.loaded();
   }
   function instructions()
   {
      if(this.containerTimeline != undefined)
      {
         this.containerTimeline.AC.gameInstructions();
      }
   }
   function play()
   {
      if(this.containerTimeline != undefined)
      {
         this.containerTimeline.AC.gamePlay();
      }
      this.mcHS.HS.play();
   }
   function levelStart(level, score)
   {
      if(this.containerTimeline != undefined)
      {
         this.containerTimeline.AC.gameLevelStart(level,score);
      }
      this.mcHS.HS.levelStart(level,score);
   }
   function mainLoop()
   {
      com.warnerbros.games.managers.FrameTimeManager.calculateFrameTime();
      this.mcHS.HS.DC.mcDC.frameTime_text.text = com.warnerbros.games.managers.FrameTimeManager.getFrameMilliseconds();
   }
   function checkLevelComplete()
   {
      return false;
   }
   function checkGameOver()
   {
      return false;
   }
   function levelComplete()
   {
      if(this.containerTimeline != undefined)
      {
         this.containerTimeline.AC.gameLevelComplete();
      }
      this.levelPauseTimer.restartTimer();
   }
   function win(level, score)
   {
      if(this.containerTimeline != undefined)
      {
         this.containerTimeline.AC.gameWin(level,score);
      }
      this.mcHS.HS.gameOver(level,score);
      this.levelPauseTimer.restartTimer();
   }
   function gameOver(level, score)
   {
      if(this.containerTimeline != undefined)
      {
         this.containerTimeline.AC.gameGameOver(level,score);
      }
      this.mcHS.HS.gameOver(level,score);
      this.levelPauseTimer.restartTimer();
   }
   function handleInput()
   {
      if(Key.isDown(com.warnerbros.games.managers.BaseInputManager.keyMap[com.warnerbros.games.managers.BaseInputManager.QUIT]))
      {
         this.gameTimeline.gotoAndPlay("gameOver");
      }
      if(Key.getCode() == 13)
      {
         this.consoleCode = "";
      }
      else if(Key.getAscii() > 45 && Key.getAscii() != this.prevConsoleCodeChar)
      {
         this.consoleCode += Key.getAscii() + ":";
         this.prevConsoleCodeChar = Key.getAscii();
      }
      if(this.consoleCode == "126:119:98:100:98:")
      {
         this.mcHS.HS.showDebugConsole();
         this.consoleCode = "";
      }
   }
   function getScore()
   {
      return 0;
   }
   function setScore(value)
   {
   }
   function getTotalScore()
   {
      return 0;
   }
   function getLevel()
   {
      return 0;
   }
   function setLevel(value)
   {
   }
   function getFrameTime()
   {
      return com.warnerbros.games.managers.FrameTimeManager.getFrameMilliseconds();
   }
   function gameDebug(msg)
   {
      if(this.gameTimeline.gDebug == undefined)
      {
         this.gameTimeline.gDebug = "";
      }
      this.gameTimeline.gDebug = this.gameTimeline.gDebug + msg + "\n";
      this.debugMsgList.push(msg);
      trace(msg);
   }
}
