class com.warnerbros.games.SoundtrackController extends com.warnerbros.games.AudioController
{
   var xmlFile;
   var phases;
   var xmlDoc;
   var owner;
   function SoundtrackController(container, xml_file)
   {
      super(container);
      this.xmlFile = xml_file;
      this.phases = new Object();
      this.xmlDoc = new com.warnerbros.games.SoundtrackXML(this);
      this.xmlDoc.ignoreWhite = true;
      this.loadXML();
   }
   function loadXML()
   {
      this.xmlDoc.onLoad = function(success)
      {
         this.owner.parseXML();
      };
      this.xmlDoc.load(this.xmlFile);
   }
   function parseXML()
   {
      for(var _loc2_ in this.xmlDoc.firstChild.childNodes)
      {
         if(this.xmlDoc.firstChild.childNodes[_loc2_].nodeName == "phase")
         {
            this.parsePhase(this.xmlDoc.firstChild.childNodes[_loc2_]);
         }
      }
   }
   function parsePhase(node)
   {
      for(var _loc3_ in node.childNodes)
      {
         if(node.childNodes[_loc3_].nodeName == "track")
         {
            this.parseTrack(node.childNodes[_loc3_],node.attributes.id);
         }
      }
   }
   function parseTrack(node, phase)
   {
      if(this.phases[phase] == undefined)
      {
         this.phases[phase] = new Array();
      }
      this.phases[phase].push(node.firstChild.nodeValue);
   }
   function playTrack(phase, loop)
   {
      var _loc3_ = Math.floor(Math.random() * this.phases[phase].length);
      this.loadSound(phase,this.phases[phase][_loc3_],false,true);
      this.playSound(phase,loop);
      this.setSoundVolume(phase,40);
   }
}
