class com.warnerbros.games.VectorMath
{
   function VectorMath()
   {
   }
   static function newVector(x, y)
   {
      return {x:x,y:y};
   }
   static function setVector(vector, x, y)
   {
      vector.x = x;
      vector.y = y;
   }
   static function copyVector(v1, v2)
   {
      v1.x = v2.x;
      v1.y = v2.y;
   }
   static function addVectors(v1, v2)
   {
      v1.x += v2.x;
      v1.y += v2.y;
   }
   static function subtractVectors(v1, v2)
   {
      v1.x -= v2.x;
      v1.y -= v2.y;
   }
   static function scaleVector(vector, scalar)
   {
      vector.x *= scalar;
      vector.y *= scalar;
   }
   static function multVectors(v1, v2)
   {
      v1.x *= v2.x;
      v1.y *= v2.y;
   }
   static function getDistance(v1, v2)
   {
      var _loc1_ = {x:0,y:0};
      com.warnerbros.games.VectorMath.copyVector(_loc1_,v1);
      com.warnerbros.games.VectorMath.subtractVectors(_loc1_,v2);
      return com.warnerbros.games.VectorMath.getMagnitude(_loc1_);
   }
   static function getMagnitude(vector)
   {
      return Math.sqrt(vector.x * vector.x + vector.y * vector.y);
   }
   static function normalizeVector(vector)
   {
      var _loc1_ = com.warnerbros.games.VectorMath.getMagnitude(vector);
      com.warnerbros.games.VectorMath.scaleVector(vector,1 / _loc1_);
   }
   static function inBounds(vector, bounds)
   {
      var _loc3_ = undefined;
      _loc3_ = vector.x >= bounds.xMin && vector.x <= bounds.xMax && vector.y >= bounds.yMin && vector.y <= bounds.yMax;
      if(vector.x < bounds.xMin)
      {
         vector.x = bounds.xMin;
      }
      if(vector.x > bounds.xMax)
      {
         vector.x = bounds.xMax;
      }
      if(vector.y < bounds.yMin)
      {
         vector.y = bounds.yMin;
      }
      if(vector.y > bounds.yMax)
      {
         vector.y = bounds.yMax;
      }
      return _loc3_;
   }
   static function newBounds(xMin, xMax, yMin, yMax)
   {
      return {xMin:xMin,xMax:xMax,yMin:yMin,yMax:yMax};
   }
   static function copyBounds(b1, b2)
   {
      b1.xMin = b2.xMin;
      b1.xMax = b2.xMax;
      b1.yMin = b2.yMin;
      b1.yMax = b2.yMax;
   }
   static function insetBounds(bounds, xinset, yinset)
   {
      bounds.xMin += xinset;
      bounds.xMax -= xinset;
      bounds.yMin += yinset;
      bounds.yMax -= yinset;
   }
}
